import javax.swing.*;
import java.awt.*;
import java.util.*;

public class DisplayTriangles extends JFrame
{
    Vector startPoints = new Vector();
    Vector endPoints = new Vector();
    Vector colors = new Vector();

    class MyPanel extends JPanel
    {
        public void paintComponent(Graphics g)
        {
            for(int i = 0; i < startPoints.size(); i++)
            {
                g.setColor((Color)colors.elementAt(i));
                Point startP = (Point)startPoints.elementAt(i);
                Point endP = (Point)endPoints.elementAt(i);
                g.drawLine(startP.x, startP.y, endP.x, endP.y);
            }
        }
    }//End class MyPanel

    MyPanel panel;
    public DisplayTriangles()
    {
        super("Visualizzazione Triangoli");
        panel = new MyPanel();
        panel.setPreferredSize(new Dimension(300, 300));
        getContentPane().add(panel, "Center");
        pack();
        setVisible(true);
    }
    public void addLine(int startX, int startY, int endX, int endY, Color color)
    {
        startPoints.addElement(new Point(startX, startY));
        endPoints.addElement(new Point(endX, endY));
        colors.addElement(color);
        repaint();
     }
     
     public void addTriangle(MyTriangle2D t, Color color)
     {
        MyPoint2D[] v = t.getVertices();
        addLine((int)v[0].getX(), (int)v[0].getY(), (int)v[1].getX(), (int)v[1].getY(), color);
        addLine((int)v[0].getX(), (int)v[0].getY(), (int)v[2].getX(), (int)v[2].getY(), color);
        addLine((int)v[1].getX(), (int)v[1].getY(), (int)v[2].getX(), (int)v[2].getY(), color);
     }

     //Test
     public static void main(String args[])
     {
         Scanner in = new Scanner(System.in);

         System.out.println("***Inserisci i vertici del triangolo***");
         System.out.print("P1: x e y? 0<=x<=100 e 0<=y<=100: ");
         MyPoint2D v1 = new MyPoint2D(in.nextDouble(), in.nextDouble());
         System.out.print("P2: x e y? 0<=x<=100 e 0<=y<=100: ");
         MyPoint2D v2 = new MyPoint2D(in.nextDouble(), in.nextDouble());
         System.out.print("P3: x e y? 0<=x<=100 e 0<=y<=100: ");
         MyPoint2D v3 = new MyPoint2D(in.nextDouble(), in.nextDouble());
         
         DisplayTriangles display = new DisplayTriangles();

         MyTriangle2D t = new MyTriangle2D(v1, v2, v3);
         display.addTriangle(t, Color.red);
         
         System.out.print("per traslare il triangolo rosso: dx dy? ");
         int dx = (int) in.nextDouble();
         int dy = (int) in.nextDouble();
         
         System.out.print("per ruotare il triangolo rosso: alpha? (in gradi) ");
         double alpha = Math.PI * in.nextDouble() / 180;

         MyTriangle2D tx = t.translate(dx, dy).rotate(alpha);
         display.addTriangle(tx, Color.green);

         System.out.print("per traslare il triangolo verde: dx dy? ");
         dx = (int) in.nextDouble();
         dy = (int) in.nextDouble();
         
         System.out.print("per ruotare il triangolo verde: alpha? (in gradi) ");
         alpha = Math.PI * in.nextDouble() / 180;

         tx = tx.translate(dx, dy).rotate(alpha);
         display.addTriangle(tx, Color.blue);

         System.out.print("per traslare il triangolo blu: dx dy? ");
         dx = (int) in.nextDouble();
         dy = (int) in.nextDouble();
         
         System.out.print("per ruotare il triangolo blu: alpha? (in gradi) ");
         alpha = Math.PI * in.nextDouble() / 180;

         tx = tx.translate(dx, dy).rotate(alpha);
         display.addTriangle(tx, Color.magenta);
         
         System.out.print("per terminare premere ctrl+C");
         
         in.close();
     }
}
