 /**
  *   classe eseguibile di prova della classe ArchivioStudenti.
  *   La classe effettua le seguenti funzioni:
  *   - istanzia e inizializza un archivio di studenti, leggendo i dati da standard input.
  *   - scrive l'archivio a standard output
  *   - istanzia un archivio contenenete solo gli studenti eccellenti e scrive il contenuto
  *     a standard output.
  *
  *   @author Adriano Luchetta
  *   @version 03-Nov-2005
  *   @version 12-Nov-2004
  */

import java.util.Scanner;

public class ProvaArchivioStudenti
{
   public static void main(String[] args)
   {
      final int VOTAZIONE_DI_ECCELLENZA = 27;

      // lettura dati da standard input
      Scanner in = new Scanner(System.in);
      ArchivioStudenti archivio = new ArchivioStudenti(in);

      // scrittura dell'archivio nel file di output
      System.out.println("***ELENCO STUDENTI IN ARCHIVIO***\n");
      System.out.println(archivio);

      // istanza ed inizializzazione dell'archivio degli studenti con media eccellente
      ArchivioStudenti nuovoArchivio = new ArchivioStudenti();
      ArchivioStudenti studentiEccellenti = new ArchivioStudenti();

      while (!archivio.isEmpty())
      {
         Studente tmpStudente = archivio.rimuovi();
         nuovoArchivio.aggiungi(tmpStudente);
         if (tmpStudente.media() > VOTAZIONE_DI_ECCELLENZA)
            studentiEccellenti.aggiungi(tmpStudente);
      }

      // scrittura a standard output dell'archivio degli studenti eccellenti
      if (!studentiEccellenti.isEmpty())
      {
         System.out.println("***ELENCO STUDENTI ECCELLENTI***\n");
         System.out.println(studentiEccellenti);
      }
      else
         System.out.println("nessuno studente eccellente!");

      // chiusura file
      in.close();
   }
}

