/**
  * MoneyTransaction
  * Rappresenta una transazione economica
  *
  * @author A. Luchetta
  * @version 7-Nov-2007
  */

public class MoneyTransaction
{
   private final String DATE;
   private final MoneyAmount MONEY_AMOUNT;
   private final String DIRECTION;

   private String comment;

   public MoneyTransaction(String aDate, double someUnits, String aCurrency, double anEuroConversionRate, String direction)
   {
      DATE = aDate;
      MONEY_AMOUNT = new MoneyAmount(someUnits, aCurrency, anEuroConversionRate);
      DIRECTION = direction;
      comment = "";
   }

   public double getConvertedToEuroUnits() {return MONEY_AMOUNT.getConvertedToEuroUnits();}

   public void addComment(String newComment)
   {
      comment += newComment;
   }

   public String toString()
   {
      return DATE + " " + DIRECTION + " " + MONEY_AMOUNT + " " + comment;
   }
 
}
